
						; simple nibble-combined sample decoder example by ws/g*p 9/2022

						;
						;
						; ... setup+init your stuff here
						;
						;

            ;---------------------------------------------------------------------
            ; simple timer setup

            lda #$7a    			; REPLAY RATE - ADJUST THIS! - LOWER = FASTER
            sta $dd04   			;         #$7a is ok-ish for 8khz sample rate
            lda #$00    			;								 and screen + sprites enabled
            sta $dd05   			;
            lda $dd0d   			;
            lda #$01    			;
            sta $dd0e   			;

            ;---------------------------------------------------------------------

            lda   #$35  			; ALL RAM UP TO $D000
            sta   $01

            ;---------------------------------------------------------------------


restartloop lda   #<sound			; reset sample pointer
            sta   readsamp+1	;
            lda   #>sound			;
            sta   readsamp+2	;
	
	
            ;--simple timer-------------------------------------------------------

replayloop  lda   #$01        ; timer
timerwait   bit   $dd0d       ;
            beq   timerwait   ;


						;-- get sample byte, hi nibble portion -------------------------------

readsamp    lda   $1234       ;load hi-lo nibble merged sample
            tay               ;store for later usage

processhi   lsr               ;
            lsr               ;
            lsr               ;
            lsr               ;shift so we have the valid 4 bits

                              ;$d418
                              ;Bits #0-#3: Volume.
                              ;Bit #4: 1 = Low pass filter enabled.
                              ;Bit #5: 1 = Band pass filter enabled.
                              ;Bit #6: 1 = High pass filter enabled.
                              ;Bit #7: 1 = Voice #3 disabled.
            ora   #%00010000  ;enable filter(s)
            sta   $d418				;digi

						;-- get sample byte, low nibble portion -----------------------------

            lda   #$01        ; timer
timerwait2  bit   $dd0d       ;
            beq   timerwait2  ;

            tya               ; get byte back
processlo   and   #$0f        ; mask so we have the valid 4 bits

            ora   #%00010000  ; enable filter(s)
            sta   $d418				; digi


						;- sample pointer ---------------------------------------------------

            inc   readsamp+1   
            bne   replayloop

            inc   readsamp+2
            lda   readsamp+2
            cmp   #>soundend
            bne   replayloop

            jmp   restartloop

;--------------------------------------------------------------------------------

*=$5000     ;sample

sound 
incbin     "new_sample.bin"

soundend    byte $00

;--------------------------------------------------------------------------------

; EOF