
								; Convert 8-bit mono wav/raw to C64 4-bit, hi/lo byte "compressed" sample

								; this converts an 8-bit raw file into a 4 bit raw file
								; sample rate must be already set To desired resolution

								
								; PREREQUISITES!
								;--------------------------------------------------
								; OPEN SAMPLE IN SFORGE
								; MAKE SAMPLE MONO
								; BIT DEPTH TO 8 BIT, RESAMPLE AT BEST GUESS (8khz is ok)
								; SAVE AS .RAW -- !!!!!!!!!!!!!!!!!!! UNSIGNED !!!!!!!!!!!!!!!!!!!!!!!
								;
								; NIBBLES WILl BE COMBINED IN BYTES:
								; conversion puts all the high nibbles together in bytes
								; original wav: $7e,$54,$34,$21.... And so forth
								; hi-nibble-wav: $70,$50,$30,$20 -->
								; combined result: --> $75,$32 
								;--------------------------------------------------

								; wertstahl 24.2.2019 -- my First python script.
								; v1.2 with file requester 7.9.2022
								; rewritten in blitz3d in 1h because python is just a pain in the head
								; success.

								; Uses Filerequester by MPZ

				
								Graphics 800,600,0,2	
								Global fntLARGE
								fntLARGE = LoadFont("Courier",14,False,False,False)

		; Explain things ---------------------------------------------------------				

								Cls

								SetFont fntLARGE

								Gosub txw : Print
								Print "  CONVERT 8-BIT RAW TO 4-BIT C64 SAMPLE * (c)2019, 2022 by wertstahl/genesis*project  "
								Print " ------------------------------------------------------------------------------------ "
								Gosub txr
								Print "      Use with caution or data may be destroyed. Use this tool at own your risk!      "
								Gosub txw
								Print " ------------------------------------------------------------------------------------ "
								Print 
								Print " PREREQUISITES : Your audio file MUST be prepared as"
								Write " - 8-bit" : Gosub txy : Write " UNSIGNED !! " : Gosub txw : Print
							    Print " - MONO "
								Print " - RAW data (no header) "
							    Print " or else the result will be garbage. The input file format is not checked."
								Print " - 8khz sample rate yields acceptable results."
								Print 
								Print " LIMITS: The maximum byte size of your input file should normally not exceed 129024 bytes. "
							    Print " Because the result would be 64512 bytes, which is the entire C64 memory minus 1024 bytes,"
								Print " which you probably need to depack/zp/stack/buffer. To enable usecases like streaming"
								Print " from disk though, there will only be a warning that your output is larger than 64512 bytes."
								Print " Files up to 64MB will be accepted - but they will take 2.5 minutes to convert, ROFL."
							    Print
								Print " FORMAT: Your input file will be converted from 8 to 4 bit-nibbles. These nibbles will"
								Print " be combined in pairs. Example: the first byte of your data is $28 and the second byte is $A9."
								Print " Thus you will get two hi-nibbles: $2 (from first byte) and $A (from second byte)."
								Print " These nibbles will be combined in one byte - Example result: $2A ."
							    Print " This information should tell you how to decode the sample file you get. "
								Print " A simple example sourcecode was provided with this converter, though: 'decoder_example.asm'. "
								Print 
								Print 
								Gosub txy : Print " >>> Press <Y> if you wish to proceed, or any other key to quit. <<<"
								Print 

								key=WaitKey()
								If key <> 121 Then Goto checkout

		; Check some basic filespecs ---------------------------------------------

								sndfilename$=""			
								sndfilename$ = getOpenFile$("SELECT RAW INPUT AUDIO","/","RAW Audio (*.raw)" + Chr$(0) + "*.raw" + Chr$(0)); flags optional
								If sndfilename$ = "" Then Goto checkout

							    z = (FileSize (sndfilename$))

								Gosub txw : Print " " + z + " bytes about To be loaded."

							    Gosub txr
								If z<4 Then Print " >> File is too small. Quitting." : Goto premature
								If z>67108864 Then Print " >> File is larger than 64MB. Quitting." : Goto premature
								Gosub txy
								If z>129024 Then Print " >> WARNING: output will be larger than 64512 bytes!"

		; Proceed with conversion ------------------------------------------------

								outz=(z/2)
								Dim outbuffer (outz)

								filein = ReadFile(sndfilename$)

								Gosub txg : Print " File selected: " + sndfilename$

		;-------------------------------------------------------------------------
						
								conv = 0	
								cc = 0
								staty = 422 ; progress percentage y position
								statx = 240 ; progress percentage x position
								Color 0,255,255 : Locate 7,staty : Print "[<ESC> TO STOP] [ CONVERTING "

		.convloop
								; convert + combine --------------------
									fz = ReadByte(filein)
											az = Int fz/16

									fz = ReadByte(filein)
											bz = Int fz/16
	
									outbuffer(conv) = Int (az*16)+bz

								; progress indicator -------------------
								cc=cc+1 : If cc < 50 Then Goto skipdraw		
								cc = 0

								part# = (conv + 1) 
								totl# = (outz - 1) 
								perx  = ( (part# / totl# ) * 100)

								Color 0,0,0 : Rect statx,staty,60,15 
								Color 0,255,255 : Locate statx,staty : Print perx + " % ]"
		.skipdraw
								If KeyHit(1) Then CloseFile(filein) : Goto abortusr

								conv = conv + 1
								If conv < outz Then Goto convloop 

		;-------------------------------------------------------------------------

								CloseFile( filein )

		;-------------------------------------------------------------------------

								Print
								Gosub txg
								Print " DONE. Size of file to be saved: " + (outz-1) + " bytes."
								Gosub txw
								Print 
								Print 

		;-------------------------------------------------------------------------

				Gosub txy : Print " >> PRESS <S> TO SAVE OR ANY OTHER KEY TO QUIT."
								
				key=WaitKey()
				If key=115 Then Gosub exportfile
				
		.checkout	
				FreeFont fntLARGE
				End
								
		;-------------------------------------------------------------------------
		;-------------------------------------------------------------------------

		.abortusr
				Gosub txr 
				Print " >>> ABORTED BY USER! PRESS ANY KEY TO EXIT <<<"
				WaitKey()

			    WaitKey()
				Goto checkout

		;-------------------------------------------------------------------------


		.premature
			   	Gosub txy
				Print " >> NO FILE. PRESS ANY KEY TO EXIT."
				WaitKey()
			    Goto checkout

		;-------------------------------------------------------------------------

		.txy 	; yellow text
				Color 255,255,0
				Return

		.txw	; white text
				Color 255,255,255
			    Return
						
		.txg	;green text
				Color 0,255,0
			    Return
						
		.txr	;red text
				Color 255,0,0
			    Return

		;-------------------------------------------------------------------------
		; write source code file to disk
		;-------------------------------------------------------------------------


		.exportfile
			
				fullfilename$ = getsaveFile$("Export C64 binary","new_sample.bin","Binary file without loading bytes (*.bin)" + Chr$(0) + "*.bin" + Chr$(0)) ; flags optional
				If fullfilename$ = "" Then Goto premature
				fileout = WriteFile (fullfilename$)
	
				
		;--------------------------------------------------------------------------------------------------
				
						For fn = 1 To outz-1
							fz = Int (outbuffer(fn))
							WriteByte (fileout,fz)
						Next

				CloseFile (fileout)

			   	Gosub txg
				Print " >> SAVED. PRESS ANY KEY TO EXIT."
				WaitKey()


				Return
				
				

		;--------------------------------------------------------------------------------------------------
		;--------------------------------------------------------------------------------------------------
		;--------------------------------------------------------------------------------------------------


								
								
								
								
								
								
								
								
	; third-pary functions below
	;
	;--------------------------------------------------------------------------------------------
	;--------------------------------------------------------------------------------------------


			
			;----------------------------------------------------------------
			; ID: 916
			; Author: MPZ
			; Date: 2004-02-05 03:08:51
			; Title: Blitz3D Filerequester (2.Update)
			; Description: Use a Filerequester in Blitz 3D
			; This Procedure is for free MPZ (@) from Berlin
			; Version 0.2 1/2004
			; 
			; in the USERLIBS must be the file kernel32.decls
			; .lib "kernel32.dll"
			; api_RtlMoveMemory(Destination*,Source,Length) : "RtlMoveMemory"
			;			
			; in the USERLIBS must be the file comdlg32.decls
			; .lib "comdlg32.dll"
			; api_GetOpenFileName% (pOpenfilename*) : "GetOpenFileNameA"
			; api_GetSaveFileName% (pOpenfilename*) : "GetSaveFileNameA"
			
			Global hWnd=SystemProperty("AppHWND")
			
			; GetOpen/saveFileName consts Flags (useful ones only!)...
			Const OFN_CREATEPROMPT         = $2000    ; Prompts the user as to whether they want to create a file that doesnt exist.
			Const OFN_FILEMUSTEXIST        = $1000    ; File must exist for it to be returned.
			Const OFN_HIDEREADONLY         = 4        ; Hides the read only button in the dialog...
			Const OFN_NOCHANGEDIR          = 8        ; Stops the user from changing the initial directory.
			Const OFN_NONETWORKBUTTON      = $20000   ; Hides and disables the network button.
			Const OFN_NOREADONLYRETURN     = $8000    ; Stops the requester returning readonly files..
			Const OFN_NOVALIDATE           = 256      ; If selected, no check will be done for invalid characters.
			Const OFN_OVERWRITEPROMPT      = 2        ; Prompt for overwrite file...
			Const OFN_PATHMUSTEXIST        = $800     ; Specifies that the path MUST exist for it to be able to be selected.
			Const OFN_READONLY             = 1        ; Makes the read only checkbox in the dialog box to be checked immediately.
			
			; getopenfile $(Title_of_Requester$, SearchPath$,Files_with_ending$, Flags); 	
			; getsavefile $(Title_of_Requester$, Save_File_name$,Files_with_ending$, Flags); 	
			;
			; Title_of_Requester$= "Name of the Requester / Name des Dateifragefensters
			; SearchPath$ = "C:\" ; Path for File searching / Pfad wo nach der Datei gesuchet werden soll 
			; Files_with_ending$ = "All Files (*.*)" + Chr$(0) + "*.*" + Chr$(0)
			;					 = "Blitzbasic" + Chr$(0) + "*.bb" + Chr$(0) + "Text" + Chr$(0) + "*.txt" + Chr$(0)
			; Flags = See Flag lists
			; Save_File_name$ = "C:\test.bb" ; Name of the Savefile with Path / Name der Datei mit Pfad zum speichern
			
			
			;example code:
			
			;Print getopenfile$("File open / Datei ffnen","%UserProfile%\Desktop\","Trajed Project Files (*.traj)" + Chr$(0) + "*.traj" + Chr$(0)); flags optional
			
			;Print getsavefile$("File Save / Datei sichern","new_project.traj","Trajed Project File (*.traj)" + Chr$(0) + "*.traj" + Chr$(0) + "Text" + Chr$(0) + "*.txt" + Chr$(0));; flags optional
			
			;While MouseHit(1) <> 1
			;Wend
			;End
			
			;-------------------------------------------------------------------------------
			
				Function getOpenFile$(lpstrTitle$,lpstrInitialDir$,lpstrFilter$,flags=$1000)
			
				nextOffset%=0 
				theBank=CreateBank(76)
				lStructSize=76
				PokeInt theBank,nextOffset%,lStructSize
				nextOffset%=nextOffset%+4 
			
				hwndOwner=hWnd
				PokeInt theBank,nextOffset%,hwndOwner
				nextOffset%=nextOffset%+4 
			
				hInstance=0
				PokeInt theBank,nextOffset%,hInstance
				nextOffset%=nextOffset%+4 
			
				If lpstrFilter$ = "" Then
				lpstrFilter$ = "All Files (*.*)" + Chr$(0) + "*.*" + Chr$(0)+ Chr$(0)
				Else	
				lpstrFilter$ = lpstrFilter$ + Chr$(0)	
				End If
				lpstrFilter_ = CreateBank(Len(lpstrFilter$)) 
				string_in_bank(lpstrFilter$,lpstrFilter_)
				PokeInt theBank,nextOffset%,AddressOf(lpstrFilter_)
				nextOffset%=nextOffset%+4
			
				lpstrCustomFilter=0
				PokeInt theBank,nextOffset%,lpstrCustomFilter
				nextOffset%=nextOffset%+4 
			
				nMaxCustFilter=0
				PokeInt theBank,nextOffset%,nMaxCustFilter
				nextOffset%=nextOffset%+4 
			
				nFilterIndex=0
				PokeInt theBank,nextOffset%,nFilterIndex
				nextOffset%=nextOffset%+4 
			
				lpstrFile$= String$ (" ", 254)
				lpstrFile_ = CreateBank(Len(lpstrFile$)+1) 
				string_in_bank(lpstrFile$+Chr$(0),lpstrFile_)
				PokeInt theBank,nextOffset%,AddressOf(lpstrFile_)
				nextOffset%=nextOffset%+4 
			
				nMaxFile=255
				PokeInt theBank,nextOffset%,nMaxFile
				nextOffset%=nextOffset%+4 
			
				lpstrFileTitle$=String$ (" ", 254)
				lpstrFileTitle_ = CreateBank(Len(lpstrFileTitle$)) 
				string_in_bank(lpstrFileTitle$,lpstrFileTitle_)
				PokeInt theBank,nextOffset%,AddressOf(lpstrFileTitle_)
				nextOffset%=nextOffset%+4 
			
				nMaxFileTitle=255
				PokeInt theBank,nextOffset%,nMaxFileTitle
				nextOffset%=nextOffset%+4 
			
				If lpstrInitialDir$="" Then
				lpstrInitialDir$="c:\"+Chr$(0)
				Else
				lpstrInitialDir$=lpstrInitialDir$+Chr$(0)
				End If
				lpstrInitialDir_ = CreateBank(Len(lpstrInitialDir$)) 
				string_in_bank(lpstrInitialDir$,lpstrInitialDir_)
				PokeInt theBank,nextOffset%,AddressOf(lpstrInitialDir_)
				nextOffset%=nextOffset%+4 
			
				If lpstrTitle$="" Then
				lpstrTitle$="Open"+Chr$(0) 
				Else
				lpstrTitle$ = lpstrTitle$ + Chr$(0)
				End If	
				lpstrTitle_ = CreateBank(Len(lpstrTitle$)) 
				string_in_bank(lpstrTitle$,lpstrTitle_)	
				PokeInt theBank,nextOffset%,AddressOf(lpstrTitle_)
				nextOffset%=nextOffset%+4 
			
				PokeInt theBank,nextOffset%,flags
				nextOffset%=nextOffset%+4 
			
				nFileOffset=0
				PokeShort theBank,nextOffset%,nFileOffset
				nextOffset%=nextOffset%+2
			
				nFileExtension=0
				PokeShort theBank,nextOffset%,nFileExtension
				nextOffset%=nextOffset%+2
				
				lpstrDefExt=0
				PokeInt theBank,nextOffset%,lpstrDefExt
				nextOffset%=nextOffset%+4 
			
				lCustData=0
				PokeInt theBank,nextOffset%,lCustData
				nextOffset%=nextOffset%+4 
			
				lpfnHook=0
				PokeInt theBank,nextOffset%,lpfnHook
				nextOffset%=nextOffset%+4 
			
				lpTemplateName$=""+Chr$(0)
				lpTemplateName_ = CreateBank(Len(lpTemplateName$)) 
				string_in_bank(lpTemplateName$,lpTemplateName_)
				PokeInt theBank,nextOffset%,AddressOf(lpTemplateName_)
				nextOffset%=nextOffset%+4 
				If api_GetOpenFileName (theBank) Then
				lpstrFile$ = bank_in_string$(lpstrFile_)
				Else
				lpstrFile$ =""
				End If
				FreeBank theBank
				FreeBank lpstrFilter_
				FreeBank lpstrFile_
				FreeBank lpstrFileTitle_
				FreeBank lpstrInitialDir_
				FreeBank lpstrTitle_
				FreeBank lpTemplateName_
				Return lpstrFile$
				
				End Function
			
			;--------------------------------------------------------------------------------------
			
			Function getsaveFile$(lpstrTitle$,lpstrFile$,lpstrFilter$,flags=2) ; Get a SAVEFILENAME
			
				nextOffset%=0 
				theBank=CreateBank(76)
				lStructSize=76
				PokeInt theBank,nextOffset%,lStructSize
				nextOffset%=nextOffset%+4 
					
				hwndOwner=hWnd
				PokeInt theBank,nextOffset%,hwndOwner
				nextOffset%=nextOffset%+4 
					
				hInstance=0
				PokeInt theBank,nextOffset%,hInstance
				nextOffset%=nextOffset%+4 
			
				If lpstrFilter$ = "" Then
					lpstrFilter$ = "All Files (*.*)" + Chr$(0) + "*.*" + Chr$(0)+ Chr$(0)
				Else	
					lpstrFilter$ = lpstrFilter$ + Chr$(0)		
				End If
				lpstrFilter_ = CreateBank(Len(lpstrFilter$)) 
				string_in_bank(lpstrFilter$,lpstrFilter_)
				PokeInt theBank,nextOffset%,AddressOf(lpstrFilter_)
				nextOffset%=nextOffset%+4
					
				lpstrCustomFilter=0
				PokeInt theBank,nextOffset%,lpstrCustomFilter
				nextOffset%=nextOffset%+4 
				
				nMaxCustFilter=0
				PokeInt theBank,nextOffset%,nMaxCustFilter
				nextOffset%=nextOffset%+4 
				
				nFilterIndex=0
				PokeInt theBank,nextOffset%,nFilterIndex
				nextOffset%=nextOffset%+4 
			
				lpstrFile_ = CreateBank(255) 
				string_in_bank(lpstrFile$+Chr$(0),lpstrFile_)
				PokeInt theBank,nextOffset%,AddressOf(lpstrFile_)
				nextOffset%=nextOffset%+4
				
				nMaxFile=255
				PokeInt theBank,nextOffset%,nMaxFile
				nextOffset%=nextOffset%+4 
				
				lpstrFileTitle$=String$ (" ", 254)
				lpstrFileTitle_ = CreateBank(Len(lpstrFileTitle$)) 
				string_in_bank(lpstrFileTitle$,lpstrFileTitle_)
				PokeInt theBank,nextOffset%,AddressOf(lpstrFileTitle_)
				nextOffset%=nextOffset%+4  
				
				nMaxFileTitle=255
				PokeInt theBank,nextOffset%,nMaxFileTitle
				nextOffset%=nextOffset%+4 
				
				lpstrInitialDir$=""+Chr$(0)
				lpstrInitialDir_ = CreateBank(Len(lpstrInitialDir$)) 
				string_in_bank(lpstrInitialDir$,lpstrInitialDir_)
				PokeInt theBank,nextOffset%,AddressOf(lpstrInitialDir_)
				nextOffset%=nextOffset%+4 
				
				If lpstrTitle$="" Then
					lpstrTitle$="Save"+Chr$(0) 
				Else
					lpstrTitle$ = lpstrTitle$ + Chr$(0)
				End If	
				lpstrTitle_ = CreateBank(Len(lpstrTitle$)) 
				string_in_bank(lpstrTitle$,lpstrTitle_)	
				PokeInt theBank,nextOffset%,AddressOf(lpstrTitle_)
				nextOffset%=nextOffset%+4 
			
				PokeInt theBank,nextOffset%,flags
				nextOffset%=nextOffset%+4 
				
				nFileOffset=0
				PokeShort theBank,nextOffset%,nFileOffset
				nextOffset%=nextOffset%+2
				
				nFileExtension=0
				PokeShort theBank,nextOffset%,nFileExtension
				nextOffset%=nextOffset%+2
				
				lpstrDefExt=0
				PokeInt theBank,nextOffset%,lpstrDefExt
				nextOffset%=nextOffset%+4 
				
				lCustData=0
				PokeInt theBank,nextOffset%,lCustData
				nextOffset%=nextOffset%+4 
				
				lpfnHook=0
				PokeInt theBank,nextOffset%,lpfnHook
				nextOffset%=nextOffset%+4 
			
				lpTemplateName$=""+Chr$(0)
				lpTemplateName_ = CreateBank(Len(lpTemplateName$)) 
				string_in_bank(lpTemplateName$,lpTemplateName_)
				PokeInt theBank,nextOffset%,AddressOf(lpTemplateName_)
			
				If api_GetSaveFileName (theBank) Then
					lpstrFile$ = bank_in_string$(lpstrFile_)
				Else
					lpstrFile$ =""
				End If
				FreeBank theBank
				FreeBank lpstrFilter_
				FreeBank lpstrFile_
				FreeBank lpstrFileTitle_
				FreeBank lpstrInitialDir_
				FreeBank lpstrTitle_
				FreeBank lpTemplateName_
				Return lpstrFile$
			End Function
			
			Function AddressOf(Bank) ; Find the correct Adress of a Bank (for C *Pointer)
				Local Address = CreateBank(4) 
				api_RtlMoveMemory(Address,Bank+4,4) 
				Return PeekInt(Address,0) 
			End Function
			
			Function string_in_bank(s$,bankhandle) ; Put a String in a Bank
				Local pos=1
				Local pos2=0
				Repeat
					PokeByte(bankhandle,pos2,Asc(Mid(s$,pos,Len(s$))))
					pos=pos+1
					pos2=pos2+1
				Until pos=Len(s$)+1
			End Function
			
			Function bank_in_string$(bankhandle) ; Get a String from a Bank
				Local s$=""
				Local pos=0
				Repeat
					s$=s$+Chr(PeekByte(bankhandle,pos))
					pos=pos+1
				Until pos=BankSize(bankhandle)
				s$=Replace$(s$,Chr(0)," ")
				Return s$
			End Function
			
	;--------------------------------------------------------------------------------------------------------
	; End third-party functions
	;--------------------------------------------------------------------------------------------------------
	
;~IDEal Editor Parameters:
;~C#Blitz3D